/**
 * Title:        Experiment 2
 * Description:  This experiment is to test how to use stored procedure to reduce communication between server and client.
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Hui Wan
 * @version 1.0
 */

/*This is the class to test update data at client side.*/

import java.sql.*;
import java.util.*;

public class ClientJavaClass {
  long transStartTime;      // transaction start time
  long transEndTime;        // transaction end time
  long transResponseTime;    // transaction response time
  static float max = 40000;

  Statement s;
  Vector resultString ;


  public int ClientJava(Connection con) {
    // get start time
    transStartTime = System.currentTimeMillis();
    resultString = new Vector();

    try // do your task here
    {
       //You already got connection here: con
       //Look at ClearClass.java for reference.
    }  //end of try
    catch (SQLException sqle)
    {
        CloseQuery(s, con);
        if (sqle.getErrorCode()==1205)        //Sybase deadlock error code
        {
            return -5;                     //deadlock error code specified in TPPT
        }
        String output = new String("ClientJavaClass.ClientJava: Failed.\n");
        resultString.addElement(output);
        System.out.print(output);
        System.out.print(sqle.getMessage());

        return -2;     //other SQLexceptions error code
    }


    transEndTime = System.currentTimeMillis(); // get end time
    transResponseTime = transEndTime - transStartTime;  // get response time

    System.out.println(transResponseTime);
    return (int)transResponseTime;  // return response time if successful
  }//end of method ClientJava

 public boolean CloseQuery(Statement stmt, Connection con)
 {
 // performs routine checks when closing a query
    try
    {
         stmt.close();
         con.rollback();
         con.setAutoCommit(true);
    }  //end of try

    catch (SQLException sqle)
    {
        return false;
    }  //end of catch
     return true;
 }//end of method CloseQuery

 // returning infomation to TPPT
 public String[] OutputResult()
 {
     return (String[])resultString.toArray();
 }

}
